﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO.Ports;

namespace proves
{
    class Program
    {
        static bool acabar = false;

        static void Main(string[] args)
        {

            // Declarar variables
            byte[] rebut = new byte[12];
            String liniaPerEscriure = String.Empty;

            // Port sèrie
            SerialPort ps = new SerialPort("COM1", 19200, Parity.None, 8, StopBits.One);
            ps.Open();

            byte[] dadesRebudes = new byte[12];             // Dades rebudes
            double[] dadesTransformades = new double[6];    // Dades transformades
            bool primeraLectura = true;
            double[] zeroVelocitatAngular = new double[2];

            // Programa ppal             
            while (!acabar)
            {
                liniaPerEscriure = String.Empty;
                for (int i = 0; i < 12; i++)
                {
                    ps.Read(rebut, 0, 1);
                    dadesRebudes[i] = rebut[0];
                }

                // dadesRebudes està plena amb els valors llegits. Transformem valors
                // Pels eixos treiem els 2 últims bits, fem el C2 i multipliquem pel factor de conversió
                for (int i = 0; i < 3; i++)
                {
                    byte v1, v2;
                    v1 = dadesRebudes[2 * i];               // Byte alt
                    v2 = dadesRebudes[(2 * i) + 1];         // Byte baix
                    v2 = (byte)(v2 & 0xFC);                 // Posar els 2 últims bits a 0

                    dadesTransformades[i] = (complementA2(v1, v2) >> 2) * 0.00025 * 9.81;
                }
                //Apliquem els valors de calibració de l'acceleròmetre
                dadesTransformades[0] = (dadesTransformades[0] + 0.06) * 9.81 / 9.95;
                dadesTransformades[1] = (dadesTransformades[1] + 0.03) * 9.81 / 9.97;
                dadesTransformades[2] = (dadesTransformades[2] - 0.55) * 9.81 / 10.05;
                // Pels valors analògics apliquem el factor de conversió i situem el zero real
                for (int i = 3; i < 5; i++)
                {
                    dadesTransformades[i] = ((dadesRebudes[2 * i] << 8) + dadesRebudes[(2 * i) + 1]) * 3.3 / (1024 * 0.0091);
                    //Dades de calibració del giroscòpic a 0º/s
                    if (primeraLectura == true)
                    {
                        zeroVelocitatAngular[i - 3] = dadesTransformades[i];
                    }
                    dadesTransformades[i] = dadesTransformades[i] - zeroVelocitatAngular[i - 3];
                }
                primeraLectura = false;

                // Pels valors de la brúixola apliquem el factor de conversió
                dadesTransformades[5] = ((dadesRebudes[10] << 8) + dadesRebudes[11]) * 1.0 / 10;

                for (int i = 0; i < 6; i++)
                {
                    liniaPerEscriure = liniaPerEscriure + dadesTransformades[i].ToString().Replace(',', '.');
                    if (i < 5) liniaPerEscriure = liniaPerEscriure + ", ";
                }

                Console.WriteLine("Valors finals: " + liniaPerEscriure);

                System.IO.StreamWriter fitxer = new System.IO.StreamWriter(@"d:\JOEL\dades.txt", true);
                fitxer.WriteLine(liniaPerEscriure);
                fitxer.Close();
            }

            ps.Close();
        }

        // Altres funcions
        static short complementA2(byte byteH, byte byteL)
        {
            byte[] data = new byte[2];
            data[0] = byteL;
            data[1] = byteH;
            short res = System.BitConverter.ToInt16(data, 0);
            return (res);
        }
    }
}
