;*************************************************************************************************************************
;*************************************************************************************************************************
;      						RUTINES PEL PROTOCOL DE COMUNICACI PER UART

;					Autor:		Joel Muoz Puigdevall
;					Projecte:	Disseny i desenvolupament d'un sistema de posicionament inercial
;					Data: 		20/02/2012


;Conjunt de rutines per al protocol de comunicaci per UART mitjanant un microcontrolador PIC16F886.

;*************************************************************************************************************************
;*************************************************************************************************************************
;Inicialitzaci protocol de transmissi per UART:
UART_I	   		bsf		STATUS,RP0			;Banc 1
				bsf		TRISC,7				;RC7/Rx entrada
				bcf		TRISC,6				;RC6/Tx sortida
				movlw	b'00100100'	
				movwf	TXSTA				;TX a On, mode assncron amb 8 bits i alta velocitat
				movlw	.12
				movwf	SPBRG				;19200 bauds amb Fosc=4MHz
				bcf		STATUS,RP0			;Banc 0
				bsf		RCSTA,SPEN			;UART en On
				return

;*************************************************************************************************************************
;Transmissi de dades per UART:
UART_T			movf	INDF,W
				movwf	TXREG				;Guardem dada a transmetre al buffer de sortida
				incf	FSR					;Incrementem punter
				bsf		STATUS,RP0			;Banc 1
UART_Wait		btfss	TXSTA,TRMT			;Dada transmesa?
				goto	UART_Wait			;No, esperar
				bcf		STATUS,RP0			;Si, Banc 0
				decfsz	Memoria				;S'han enviat les 30 dades?
				goto	UART_T				;No, segueix enviant
				return

;*************************************************************************************************************************